Skip to main content

Depth-first-search - medium level - question 2

Depth-first-search - medium level - question 2


2115. Find All Possible Recipes from Given Supplies

You have information about n different recipes. You are given a string array recipes and a 2D string array ingredients. The ith recipe has the name recipes[i], and you can create it if you have all the needed ingredients from ingredients[i]. Ingredients to a recipe may need to be created from other recipes, i.e., ingredients[i] may contain a string that is in recipes.

You are also given a string array supplies containing all the ingredients that you initially have, and you have an infinite supply of all of them.

Return a list of all the recipes that you can create. You may return the answer in any order.

Note that two recipes may contain each other in their ingredients.


Constraints:


n == recipes.length == ingredients.length

1 <= n <= 100

1 <= ingredients[i].length, supplies.length <= 100

1 <= recipes[i].length, ingredients[i][j].length, supplies[k].length <= 10

recipes[i], ingredients[i][j], and supplies[k] consist only of lowercase English letters.

All the values of recipes and supplies combined are unique.

Each ingredients[i] does not contain any duplicate values.



Analysis:

The main concern to this problem is time complexity.

One logic to this question is that once recipe may becomes an available ingredient to other recipes, which may make the previously un-created recipes becomes creatable.

If we handle the above situation to scan all the ingredients again, the time complexity would be too large, since for each newly created recipe, we need to a scan of all the ingredients.

But one scan needs O(numb of ingredients * numb of each ingredients) which is ~ 10^4.

The overall time complexity is O(numb of recipes * num of scans) ~ 10^6, which seems to be Okay for the OJ of Leetcode. But somehow cannot pass it and observed the following output with the following code,

112 / 112 test cases passed, but took too long.

class Solution {
public:
    vector<string> findAllRecipes(vector<string>& recipes, vector<vector<string>>& ingredients, vector<string>& supplies) {
        vector<string> res;
        int n = recipes.size();
        unordered_set<string> st;
        for(auto &a : supplies) st.insert(a);
        queue<int> q;
        q.push(-1);
        while(q.size()) {
            auto t = q.front();
            q.pop();
            cout<<t<<endl;
            for(int i=0; i<n; ++i) {
                if(st.count(recipes[i]) > 0) continue;
                bool flag = true;
                for(auto &a : ingredients[i]) {
                    if(st.count(a) == 0) {
                        flag = false;
                        break;
                    }
                }
                if(flag) {
                    st.insert(recipes[i]);
                    q.push(i);
                }
            }
        }
        for(int i=0; i<n; ++i) {
            if(st.count(recipes[i]) > 0) res.push_back(recipes[i]);
        }
        return res;
    }
};


How can we make it faster?

We do not need to rescan every ingredient once creating a recipe. If we consider the relationship between recipes & ingredients, it looks like a "build graph": the recipe is the build target, and all the ingredients are the dependencies.

So we try to use a top-down dfs method: when all the dependencies can be built, then the initial (or root) built target can be built as well. So it is a dfs problem in nature.

One place is that: we could have cyclic dependencies, so need to take care of this case by tracking the path when do the dfs.


See the code below:


class Solution {
public:
    vector<string> findAllRecipes(vector<string>& recipes, vector<vector<string>>& ingredients, vector<string>& supplies) {
        vector<string> res;
        int n = recipes.size();
        unordered_map<string, int> mp;
        for(int i=0; i<n; ++i) mp[recipes[i]] = i;
        unordered_set<string> st;
        for(auto &a : supplies) st.insert(a);
        for(auto &s : recipes) {
            // cout<<s<<endl;
            vector<int> visit(n, 0);
            dfs(s, mp, ingredients, st, res, visit);
        }
        return res;
    }
private:
    bool dfs(string& s, unordered_map<string, int>& mp, vector<vector<string>>& is, unordered_set<string>& st, vector<string>& res, vector<int>& visit) {
        if(mp.count(s) == 0) return false;
        if(mp[s] == -1) return true;
        int id = mp[s];
        // cout<<id<<endl;
        if(visit[id]) return false;
        visit[id] = 1;
        for(auto &a : is[id]) {
            if(st.count(a) == 0) {
                if(mp.count(a) == 0) return false;
                if(!dfs(a, mp, is, st, res, visit)) return false;
            }
        }
        res.push_back(s);
        mp[s] = -1;
        st.insert(s);
        return true;
    }
};



Upper Layer


Comments

Popular posts from this blog

Segment Tree

Segment tree can be viewed as an abstract data structure which using some more space to trade for speed. For example, for a typical question with O(N^2) time complexity, the segment tree method can decrease it to O(N*log(N)).  To make it understandable, let us consider one example. Say we have an integer array of N size, and what we want is to query the maximum with a query range [idx1, idx2], where idx1 is the left indexes, and idx2 is the right indexes inclusive. If we only do this kind of query once, then we just need to scan through the array from idx1 to idx2 once, and record the maximum, done. The time complexity is O(N), which is decent enough in most cases even though it is not the optimal one (for example, with a segment tree built, the time complexity can decrease down to O(log(N))). However, how about we need to query the array N times? If we continue to use the naïve way above, then the time complexity is O(N^2), since for each query we need to scan the query range once...

Bit Manipulation - Example

  Leetcode 136 Single Number Given a non-empty array of integers nums, every element appears twice except for one. Find that single one. You must implement a solution with a linear runtime complexity and use only constant extra space. Constraints: 1 <= nums.length <= 3 * 10^4 -3 * 10^4 <= nums[i] <= 3 * 10^4 Each element in the array appears twice except for one element which appears only once. Analysis: If there is no space limitation, this question can be solved by counting easily. But counting requires additional space. Here we can use xor (^) operation based on some interesting observations:  A^A = 0, here A is any number A^0 = A, here A is any number Since all the number appears twice except one, then all the number appear even numbers will be cancelled out, and only the number appears one time is left, which is what we want. See the code below: class Solution { public: int singleNumber(vector<int>& nums) { int res = 0; for(auto ...

Rolling Hash

Rolling hash is one common trick used to increase efficiency of substring comparisons by compressing (or hashing) a string into a integer. After this step, we can compare two strings directly without comparing each chars. So the efficiency can be increased from O(N) to O(1). So how to implement the rolling hash? First we need to choose a base for the expansion and a modulo to mod. The basic formula is (suppose the window is n, and the rolling direction is from left to right), HashVal = (A1*p^(n-1) + A2*p^(n-2) + ... + An-1*p^1 + An*p^0)%mod where HashVal is the hash value, Ai is the ith element, p is the base, and mod is the modulo. To avoid collision as much as we can, p and modulo usually need to be large prime numbers. One corner case is that the base order in the above formula cannot be reversed. Or to be more clear, if the rolling direction is from left to right in an array, the first element should be in the highest order of the base, or times p^(n-1), and the last element times ...